
Button = {}

Button.__index = Button

function Button.new(x,y,text,func)
  local self = {}
  self.x = x
  self.y = y
  self.text = text
  self.w = 250
  self.h = 50
  self.f = 0
  self.mouseover = false
  self.func = func
  self.invisible = false
  
  return setmetatable(self,Button)
end

function Button.update(self,dt)
  self.mouseover = ((love.mouse.getX() > self.x) and (love.mouse.getX() < self.x + self.w) and (love.mouse.getY() > self.y) and (love.mouse.getY() < self.y + self.h))
  
  if(self.mouseover) then
    self.f = -15
  else
    self.f = 0
  end
end

function Button.draw(self)
  if(not self.invisible) then
    love.graphics.setColor(150 + self.f,150 + self.f,150 + self.f)
    love.graphics.rectangle("fill",self.x,self.y,self.w,self.h)
    love.graphics.setColor(200 + self.f,200 + self.f,200 + self.f)
    love.graphics.rectangle("line",self.x+3,self.y+3,self.w-4,self.h-4)
    love.graphics.setColor(100 + self.f,100 + self.f,100 + self.f)
    love.graphics.rectangle("line",self.x-2,self.y-2,self.w,self.h)
  
    love.graphics.setColor(50,50,50)
    love.graphics.print(self.text,self.x+(self.w/4),self.y+15)
  end
end

function Button.mousepressed(self,x,y,button)
  if(button == 1 and self.mouseover) then
    self:pop(50)
    click:play()
    click2:play()
    self.invisible = true
    self.func()
  end
end

function Button.pop(self,amount)
  for i = 1,amount do
    table.insert(gridb.particles,#gridb.particles,Particles.new((self.x+self.w/2),(self.y + 15)))
  end
end