Game = {}

function Game.update(dt)
  love.window.setTitle("Minesweeper - LVL: "..level.. "- Score: "..math.ceil(score).." Flags: "..bombs.." Time: "..math.floor(timer))
    if(alive and not winner) then
      timer = timer + dt
    end
  
  for _,v in ipairs(grid.particles) do v:update(dt) end
  for i = #Particles, 1, -1 do if Particles[i].die then table.remove(Particles, i) end end 
  
  if(alive and not winner) then
    grid:update(dt)
  end
end

function Game.draw()
  grid:draw()
  if(not alive) then
    love.graphics.setColor(255,0,0,50)
    love.graphics.rectangle("fill",0,0,450,550)
    love.graphics.setColor(0,0,0,255)
    love.graphics.print("GAME OVER",125,75)
    love.graphics.print("Final Score   "..math.ceil(score),75,175)
    love.graphics.print("Time   "..math.floor(timer),150,275)
    love.graphics.print("Restart (Any Key)",60,375)
    love.graphics.print("HIGHSCORE "..Player.highscore,100,425)
  end
  
  if(winner) then
    love.graphics.setColor(0,255,0,50)
    love.graphics.rectangle("fill",0,0,450,550)
    love.graphics.setColor(0,0,0,255)
    love.graphics.print("YOU WON",150,75)
    love.graphics.print("SCORE  "..math.ceil(score),125,175)
    love.graphics.print("Time   "..math.floor(timer),150,275)
    love.graphics.print("CONTINUE (Any Key)",60,375)
    love.graphics.print("HIGHSCORE "..Player.highscore,100,425)
  end
end

function Game.mousepressed(x,y,button)
  if(alive or not winner) then
    grid:mousepressed(x,y,button)
  end
end

function Game.keypressed(key)
  if (winner) then
    alive = true
    winner = false
    level = level + 1
    bombs = math.floor(level)
    grid:restart()
  end
  if(not alive) then
    alive = true
    winner = false
    bombs = 1
    level = 1
    grid:restart()
    score = 0
    timer = 0
  end
end