
Grid = {}
Grid.__index = Grid

function Grid.new(w,h)
  
  local self = {}
  
  self.w = w
  self.h = h
  self.tiles = {}
  self.bombs = {}
  self.particles = {}

  return setmetatable(self,Grid)
  
end

function Grid.load(self)
  for x = 0, (self.w),50 do
    for y = 0, (self.h),50 do
      local a = Tile.new(x,y,0,#self.tiles)
      table.insert(self.tiles, #self.tiles+1,a)
      a.i = #self.tiles
      
    end
  end
  
  for i = 1,bombs do
    local x = math.random(1,99)
    self.tiles[x].type = 1
    table.insert(self.bombs,#self.bombs+1,self.tiles[x])
  end
  
end

function Grid.fake(self)
  for x = 0, (self.w),50 do
    for y = 0, (self.h),50 do
      local a = Tile.new(x,y,0,#self.tiles)
      table.insert(self.tiles, #self.tiles+1,a)
      a.i = #self.tiles
      a.clicked = true
    end
  end
end

function Grid.update(self,dt)
  for _,v in ipairs(self.tiles) do v:update(dt) end
  self:checkWin()
end

function Grid.draw(self)
  for _,v in ipairs(self.tiles) do v:draw() end
  for _,v in ipairs(self.particles) do v:draw() end
end

function Grid.mousepressed(self,x,y,button)
  for _,v in ipairs(self.tiles) do v:mousepressed(x,y,button) end
end

function Grid.restart(self)
  for i = 1,#self.tiles do
    self.tiles[i]:reset()
  end
  
  for k in pairs (self.bombs) do
    self.bombs[k] = nil
end
  
  local nums = {}
  local x
  
  for i = 1,bombs do
    repeat
      x = math.random(1,99)
    until (not contains(nums,x))
    
    table.insert(nums,#nums+1,x)
    self.tiles[nums[i]].type = 1
    
    table.insert(self.bombs,#self.bombs+1,self.tiles[nums[i]])
  end
  
end

function contains(table,value)
  for i = 1,#table do
    if(table[i] == value) then
      return true
    end
  end
  return false
end

function Grid.checkWin(self)
  local marked = 0
  for i = 1,#self.bombs do
    if(self.bombs[i].marked) then
      marked = marked + 1
    end
  end
  
  if(marked == getBombCount()) then
    
    for i = 1,99 do
      if(self.tiles[i].type == 0) then
        if(not self.tiles[i].clicked) then
          self.tiles[i]:ejectParticles(20)
        end
        self.tiles[i].clicked = true
        score = score +  mapColor(self.tiles[i].adjacent,0,8,20,1)
      end
    end
    
    win:play()
    winner = true
    
  end
  
end