
Particles = {}

Particles.__index = Particles

function Particles.new(x,y)
  
  local self = {}
  self.x = x
  self.y = y
  self.velX = math.random(-300,300)
  self.velY = math.random(-300,300)
  self.w = 1
  self.h = 1
  self.timer = 255
  self.die = false
  
  return setmetatable(self,Particles)
  
end

function Particles.update(self,dt)
  
  self.timer = self.timer - (dt*80)
  
  self.x = self.x + self.velX * dt
  self.y = self.y + self.velY * dt
  
  self.velX = self.velX - (dt*10)
  self.velY = self.velY - (dt*10)
  
  if(self.timer <= 0) then
    self:remove()
  end
  
  
end

function Particles.draw(self)
  love.graphics.setColor(155,155,200,self.timer)
  love.graphics.ellipse("fill",self.x,self.y,self.w,self.h)
end

function Particles.remove(self)
  self.die = true
end