
math.randomseed(os.time());math.random();math.random();math.random()

Slib = require("slib")

Player = {}
Player.highscore = 0

function love.load()
  
  Slib.init("Slib")
  
  if(Slib.isFirst()) then
    Player = {}
    Player.highscore = 0
  else
    Player = Slib.load()
  end
  
  font = love.graphics.newFont("8-BIT WONDER.ttf",22)
  
  first = love.audio.newSource("first.wav")
  click = love.audio.newSource("click.wav")
  click2 =love.audio.newSource("click2.wav")
  flag = love.audio.newSource("flag.wav")
  explosion = love.audio.newSource("explosion.wav")
  explosion2 = love.audio.newSource("explosion2.wav")
  lose = love.audio.newSource("win.wav")
  win = love.audio.newSource("lose.wav")
  
  love.window.setTitle("Minesweeper")
  love.window.setMode(450,550)
  require("Grid")
  require("Tile")
  require("Particles")
  require("Button")
  require("Menu")
  require("Game")
  
  grid = Grid.new(400,500)
  grid:load()
  
  gridb = Grid.new(400,500)
  gridb:fake()
  
end

level = 1
score = 0
bombs = 1

winner = false
alive = true

timer = 0

state = "menu"

function love.update(dt)
  if(state == "menu") then
    Menu.update(dt)
  elseif(state == "game") then
    Game.update(dt)
    if(score > Player.highscore) then
      Player.highscore = math.ceil(score)
      Slib.saveE(Player)
    end
  end
end

function love.draw()
  love.graphics.setFont(font)
  if(state == "menu") then
    Menu.draw()
  elseif(state == "game") then
    Game.draw()
  end
end

function love.mousepressed(x,y,button)
  if(state == "menu") then
    Menu.mousepressed(x,y,button)
  elseif(state == "game") then
    Game.mousepressed(x,y,button)
  end
end


function love.keypressed(key)
  if(state == "game") then
    Game.keypressed(key)
  end
end


